<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import AssassinationPrompt from "./lib/AssassinationPrompt.svelte";
  import CharacterCardBack from "./lib/CharacterCardBack.svelte";
  import CharacterCardFront from "./lib/CharacterCardFront.svelte";
  import MissionCardFront from "./lib/MissionCardFront.svelte";
  import MissionPlayerHand from "./lib/MissionPlayerHand.svelte";
  import PhaseDescription from "./lib/PhaseDescription.svelte";
  import Speech from "./lib/Speech.svelte";
  import TeamIcon from "./lib/TeamIcon.svelte";
  import TeamProposingForm from "./lib/TeamProposingForm.svelte";
  import TeamVoteReveal from "./lib/TeamVoteReveal.svelte";
  import TeamVotingForm from "./lib/TeamVotingForm.svelte";
  import {
    getAffiliation,
    getMissionStructure,
    getSpyCount,
    isAssassination,
    isGameComplete,
    isMissionInProgress,
    isMissionReveal,
    isPlayerActive,
    isTeamProposing,
    isTeamVoteReveal,
    isTeamVoting,
  } from "./lib/theResistance";
  import { reordered } from "./lib/utils";
  import { fade, fly } from "svelte/transition";

  const dispatch = createEventDispatcher();
  function performAction(action: Action) {
    dispatch("action", action);
  }

  export let state: GameState;
  export let userId: PlayerId | null;
  export let settings: Settings;

  $: phase = state.phase;
  $: players = reordered(state.players, userId);
  $: missionStructure = getMissionStructure(state.players.length);

  $: user = state.players.find((p) => p.id === userId);

  function getPlayerStyle(playerCount: number, playerIndex: number): string {
    let angleStep = (2 * Math.PI) / playerCount;
    let startAngle = Math.PI / 2;
    let angle = startAngle + angleStep * playerIndex;
    let radius = 24 + playerCount / 2;

    return `
      --translate-x: ${(radius * Math.cos(angle)).toFixed(2)}rem;
      --translate-y: ${(radius * Math.sin(angle)).toFixed(2)}rem;
    `;
  }
</script>

<div class="game">
  <div class="center">
    <div class="before-board">
      <PhaseDescription {state} {user} />
    </div>
    <div class="board panel">
      <div class="missions">
        {#each missionStructure as mission, i}
          <div class="mission">
            <div class="mission-number">Mission {i + 1}</div>

            <div class="mission-team-size">
              {#if state.missions[i]}
                <TeamIcon affiliation={state.missions[i].winner} />
              {:else}
                {mission.teamSize}
              {/if}
            </div>

            {#if mission.twoFailsRequired}
              <div class="mission-two-fails">two fails <br /> required</div>
            {/if}
          </div>
        {/each}
        <div />
      </div>
      <div class="board-bottom-row">
        <span>
          Failed votes: {state.failedVotes} / 5
        </span>
        <span>
          There are {getSpyCount(state.players.length)} spies.
        </span>
      </div>
    </div>
    <div class="after-board">
      {#if isTeamProposing(phase)}
        <TeamProposingForm variant="below-board" {state} {user} on:action />
      {:else if isTeamVoting(phase)}
        <TeamVotingForm {state} {phase} {user} on:action />
      {:else if isTeamVoteReveal(phase)}
        <TeamVoteReveal
          variant="below-board"
          {state}
          {phase}
          {user}
          on:action
        />
      {:else if isMissionReveal(phase)}
        <ul class="revealed-mission-cards">
          {#each phase.MissionReveal.cards as card}
            <li><MissionCardFront {card} /></li>
          {/each}
        </ul>
        {#if user && isPlayerActive(state, user.id)}
          <button class="primary" on:click={() => performAction({ Ready: {} })}>
            I'm ready!
          </button>
        {/if}
      {:else if isAssassination(phase)}
        <AssassinationPrompt {state} {user} on:action />
      {/if}
    </div>
  </div>

  {#each players as player, i (player.id)}
    <div
      class="player"
      class:user={user?.id === player.id}
      style={getPlayerStyle(players.length, i)}
    >
      <div class="player-inner">
        {#if isMissionInProgress(phase)}
          <div class="player-hand" transition:fly={{ y: 100, duration: 500 }}>
            <MissionPlayerHand {state} {phase} {player} {user} on:action />
          </div>
        {/if}

        <gs6-player-box
          userid={player.id}
          active={isPlayerActive(state, player.id)}
          speaking={!!state.speech[player.id]}
        >
          {#if phase.RoleAssigning && !phase.RoleAssigning.ready.includes(player.id)}
            <!-- Do not show card yet -->
          {:else}
            <div
              class="player-character-card"
              in:fly={{ y: -100, duration: 500 }}
            >
              {#if player.id === userId || (isAssassination(phase) && getAffiliation(player.hand) === "Spies") || isGameComplete(phase)}
                <CharacterCardFront card={player.hand} />
              {:else}
                <CharacterCardBack />
              {/if}
            </div>
          {/if}

          {#if player.id === state.leader}
            <span class="leader-icon emoji">🎖️</span>
          {/if}

          {#if state.speech[player.id]}
            <span slot="speech">
              <Speech speech={state.speech[player.id]} {player} />
            </span>
          {/if}
        </gs6-player-box>
      </div>
    </div>
  {/each}

  {#if user && phase.RoleAssigning && !phase.RoleAssigning.ready.includes(user.id)}
    <div
      class="prompt panel"
      in:fade={{ duration: 100 }}
      out:fly={{ y: 100, duration: 500 }}
    >
      <h2>You are</h2>

      <CharacterCardFront card={user.hand} />
      {#if user.hand.Merlin || getAffiliation(user.hand) === "Spies"}
        <h3>These are the spies:</h3>
        <ul class="spy-list">
          {#each state.players.filter((p) => getAffiliation(p.hand) === "Spies") as spy}
            <li><gs6-user userid={spy.id} /></li>
          {/each}
        </ul>
      {/if}

      <button class="primary" on:click={() => performAction({ Ready: {} })}>
        I'm ready
      </button>
    </div>
  {/if}
</div>

<style>
  .game {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .game :global(em) {
    font-style: italic;
    font-weight: 300;
  }

  .center {
    position: relative;
  }

  .before-board {
    width: 20rem;

    position: absolute;
    top: -7.5rem;
    left: 50%;
    transform: translate(-50%, -100%);
  }

  .after-board {
    width: 30rem;
    position: absolute;
    bottom: -7.5rem;
    left: 50%;
    transform: translate(-50%, 100%);

    display: flex;
    flex-direction: column;
    align-items: center;
  }

  .revealed-mission-cards {
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
    justify-content: center;

    font-size: 0.6rem;
  }

  .revealed-mission-cards > * {
    margin: 0.5rem;
  }

  .board {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    background-color: linen;
  }

  .missions {
    display: flex;
    flex-direction: row;
  }

  .mission {
    margin: 1em;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: flex-start;
  }

  .mission-number {
    white-space: nowrap;
  }
  .mission-team-size {
    font-weight: 500;
    font-size: 3em;
  }

  .board-bottom-row {
    display: flex;
    flex-direction: row;
    justify-content: space-between;

    border-top: #aaaa solid 1px;
    padding-top: 0.25em;
  }

  .player {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%)
      translate(var(--translate-x), var(--translate-y));
  }
  .player-inner {
    position: relative;
  }

  .player-hand {
    font-size: 55%;
    position: absolute;
    left: 50%;
    top: 0;
    transform: translate(-50%, -80%);
  }
  .user .player-hand {
    font-size: 80%;
    transform: translate(-50%, -100%) translateY(-0.5rem);
  }

  .player-character-card {
    font-size: 45%;

    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 100%) translateY(-0.67rem);
  }

  .leader-icon {
    font-size: 3em;
    position: absolute;
    left: 0;
    top: 50%;
    transform: translate(-50%, -50%) translateX(-0.25rem);
  }

  .prompt {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    min-width: 15rem;

    display: flex;
    flex-direction: column;
    align-items: center;
  }
  .prompt > *:not(:first-child) {
    margin-top: 1rem;
  }
  .prompt > *:not(:last-child) {
    margin-bottom: 1rem;
  }

  .spy-list {
    display: flex;
    flex-direction: column;
  }
  .spy-list > * {
    margin-top: 0.25rem;
    margin-bottom: 0.25rem;
  }
</style>
